// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_platform_msgs:msg/SpeedPedals.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED_PEDALS__TRAITS_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED_PEDALS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_platform_msgs/msg/detail/speed_pedals__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace automotive_platform_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SpeedPedals & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << ", ";
  }

  // member: throttle
  {
    out << "throttle: ";
    rosidl_generator_traits::value_to_yaml(msg.throttle, out);
    out << ", ";
  }

  // member: brake
  {
    out << "brake: ";
    rosidl_generator_traits::value_to_yaml(msg.brake, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SpeedPedals & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }

  // member: throttle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "throttle: ";
    rosidl_generator_traits::value_to_yaml(msg.throttle, out);
    out << "\n";
  }

  // member: brake
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "brake: ";
    rosidl_generator_traits::value_to_yaml(msg.brake, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SpeedPedals & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_platform_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_platform_msgs::msg::SpeedPedals & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_platform_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_platform_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_platform_msgs::msg::SpeedPedals & msg)
{
  return automotive_platform_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_platform_msgs::msg::SpeedPedals>()
{
  return "automotive_platform_msgs::msg::SpeedPedals";
}

template<>
inline const char * name<automotive_platform_msgs::msg::SpeedPedals>()
{
  return "automotive_platform_msgs/msg/SpeedPedals";
}

template<>
struct has_fixed_size<automotive_platform_msgs::msg::SpeedPedals>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<automotive_platform_msgs::msg::SpeedPedals>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<automotive_platform_msgs::msg::SpeedPedals>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__SPEED_PEDALS__TRAITS_HPP_
