// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlSettings.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__BUILDER_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "automotive_platform_msgs/msg/detail/adaptive_cruise_control_settings__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace automotive_platform_msgs
{

namespace msg
{

namespace builder
{

class Init_AdaptiveCruiseControlSettings_max_distance
{
public:
  explicit Init_AdaptiveCruiseControlSettings_max_distance(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
  : msg_(msg)
  {}
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings max_distance(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_max_distance_type arg)
  {
    msg_.max_distance = std::move(arg);
    return std::move(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

class Init_AdaptiveCruiseControlSettings_cipv_percent
{
public:
  explicit Init_AdaptiveCruiseControlSettings_cipv_percent(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
  : msg_(msg)
  {}
  Init_AdaptiveCruiseControlSettings_max_distance cipv_percent(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_cipv_percent_type arg)
  {
    msg_.cipv_percent = std::move(arg);
    return Init_AdaptiveCruiseControlSettings_max_distance(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

class Init_AdaptiveCruiseControlSettings_step_percent
{
public:
  explicit Init_AdaptiveCruiseControlSettings_step_percent(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
  : msg_(msg)
  {}
  Init_AdaptiveCruiseControlSettings_cipv_percent step_percent(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_step_percent_type arg)
  {
    msg_.step_percent = std::move(arg);
    return Init_AdaptiveCruiseControlSettings_cipv_percent(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

class Init_AdaptiveCruiseControlSettings_min_percent
{
public:
  explicit Init_AdaptiveCruiseControlSettings_min_percent(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
  : msg_(msg)
  {}
  Init_AdaptiveCruiseControlSettings_step_percent min_percent(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_min_percent_type arg)
  {
    msg_.min_percent = std::move(arg);
    return Init_AdaptiveCruiseControlSettings_step_percent(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

class Init_AdaptiveCruiseControlSettings_following_spot
{
public:
  explicit Init_AdaptiveCruiseControlSettings_following_spot(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
  : msg_(msg)
  {}
  Init_AdaptiveCruiseControlSettings_min_percent following_spot(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_following_spot_type arg)
  {
    msg_.following_spot = std::move(arg);
    return Init_AdaptiveCruiseControlSettings_min_percent(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

class Init_AdaptiveCruiseControlSettings_set_speed
{
public:
  explicit Init_AdaptiveCruiseControlSettings_set_speed(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings & msg)
  : msg_(msg)
  {}
  Init_AdaptiveCruiseControlSettings_following_spot set_speed(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_set_speed_type arg)
  {
    msg_.set_speed = std::move(arg);
    return Init_AdaptiveCruiseControlSettings_following_spot(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

class Init_AdaptiveCruiseControlSettings_header
{
public:
  Init_AdaptiveCruiseControlSettings_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_AdaptiveCruiseControlSettings_set_speed header(::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_AdaptiveCruiseControlSettings_set_speed(msg_);
  }

private:
  ::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::automotive_platform_msgs::msg::AdaptiveCruiseControlSettings>()
{
  return automotive_platform_msgs::msg::builder::Init_AdaptiveCruiseControlSettings_header();
}

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__ADAPTIVE_CRUISE_CONTROL_SETTINGS__BUILDER_HPP_
